(set! lyhendite_loend '(
( "1/2" "pool" )
( "a" "aasta" )
( "ca" "tsirka" )
( "cm" "senti" "meetrit" )
( "dr" "doktor" )
( "Dr" "doktor" )
( "EE" "Eesti" "Energia" )
( "eek" "krooni" )
( "EEK" "krooni" )
( "eur" "eurot" )
( "EUR" "eurot" )
( "e.k" "eesti" "keeles" )
( "EV" "Eesti" "Vabariigi" )
( "Gb" "gigabaiti" )
( "ha" "hektari" )
( "hj" "hobujudu" )
( "hr" "hrra" )
( "Hz" "hertsi" )
( "IMF" "i" "m" "f" )
( "jm" "ja" "muud" )
( "jne" "ja" "nii" "edasi" )
( "jms" "ja" "muu" "selline" )
( "jpt" "ja" "palju" "teisi" )
( "jt" "ja" "teised" )
( "jun" "juunior" )
( "k.a" "kaasa" "arvatud" )
( "kg" "kilogrammi" )
( "kk" "keskkool" )
( "kl" "klass" )
( "km" "kilomeetri" )
( "km/h" "kilomeetrit" "tunnis" )
( "kr" "krooni" )
( "kW" "kilovatti" )
( "kWh" "kilovatttundi" )
( "lk" "leheklg" )
( "lp" "lugupeetud" )
( "Lp" "lugupeetud" )
( "m" "meetrit" )
( "mA" "milliampri" )
( "Mb" "megabaiti" )
( "mh" "muuhulgas" )
( "milj" "miljonit" )
( "min" "minutit" )
( "mld" "miljardit" )
( "mlrd" "miljardit" )
( "mln" "miljonit" )
( "mm" "millimeetrit" )
( "mnt" "maantee" )
( "mnt." "maantee" )
( "Mr" "mister" )
( "Mrs" "missis" )
( "m/s" "meetrit" "sekundis" )
( "m/sek" "meetrit" "sekundis" )
( "MW" "megavatti" )
( "nn" "niinimetatud" )
( "nr" "number" )
( "nt" "niteks" )
( "n" "nii" "elda" )
( "n-" "nii" "elda" )
( "pr" "proua" )
( "pst" "puiestee" )
( "rbl" "rubla" )
( "sh" "sealhulgas" )
( "sek" "sekundit" )
( "s.o" "see" "on" )
( "s.t" "see" "thendab" )
( "st" "see" "thendab" )
( "tel" "telefon" )
( "tk" "tkki" )
( "tn" "tnav" )
( "u" "umbes" )
( "v.a" "vlja" "arvatud" )
( "vrd" "vrdle" )
( "vm" "vi" "muud" )
( "Vt" "vaata" )
( "vt" "vaata" )
))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; VIKETHED ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define lower '("a" "b" "c" "d" "e" "f" "g" "h" "i" "j" "k" "l" "m" "n" "o" "p" "q" "r" "s" "" "z" "" "t" "u" "v" "w" "" "" "" "" "x" "y" "0" "1" "2" "3" "4" "5" "6" "7" "8" "9" "." "," ":" ";"))
(define s_symbol '("*" "%" "$" "" "" "@" "&" "+" "#" ">" "<" "=" "" "-"))
(define upper_n '("A" "B" "C" "D" "E" "F" "G" "H" "I" "J" "K" "L" "M" "N" "O" "P" "Q" "R" "S" "Z" "T" "U" "V" "W" "X" "Y"))
(define VA '( "" "" "" "" "" "" "" ""))
(define VE '("" "" "" "" "" "" "" ""))
(define VI' ( "" "" "" "" "" "" "" "" "" "" "" ""))
(define VO '("" "" "" "" "" "" "" ""))
(define VU '("" "" "" "" "" ""))
(define VAE '( "" ""))
(define VOE '("" "" "" ""))
(define VN '("" ""))
(define VTS '("" "" ""))
(define VD '("" "" "" ""))



(define (eki_et_lower token)
(let ((rv "") (token_list (symbolexplode token)) (len (length token)))
;(print token)
(mapcar 
	(lambda (x) 
			(cond
				((member_string x lower) (set! rv (string-append rv x)))
				((member_string x upper_n) (set! rv (string-append rv (downcase x))))
				((string-equal x "") 
					(set! rv (string-append rv "")))
				((string-equal x "") 
					(set! rv (string-append rv "")))
				((string-equal x "") 
					(set! rv (string-append rv "")))
				((string-equal x "") 
					(set! rv (string-append rv "")))
				((string-equal x "") 
					(set! rv (string-append rv "")))				
				((string-equal x "") 
					(set! rv (string-append rv "")))				
				((and (member_string x s_symbol) (eq? len 1))  (set! rv (string-append rv x)))
				
				((member_string x VA) (set! rv (string-append rv "a")))
				((member_string x VE) (set! rv (string-append rv "e")))
				((member_string x VI) (set! rv (string-append rv "i")))
				((member_string x VO) (set! rv (string-append rv "o")))
				((member_string x VU) (set! rv (string-append rv "u")))
				((member_string x VAE) (set! rv (string-append rv "")))
				((member_string x VOE) (set! rv (string-append rv "")))
				((member_string x VN) (set! rv (string-append rv "n")))
				((member_string x VTS) (set! rv (string-append rv "s")))
				((member_string x VD) (set! rv (string-append rv "ks")))
		);cond

)
(car (list token_list)))
;(print rv)
(list rv)
))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NUMBRITE TEISENDUS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define yhed_l '("null" "ks" "kaks" "kolm" "neli" "viis" "kuus" "seitse" "kaheksa" "heksa" "kmme"))
(define yhed_l_j '("null" "esimene" "teine" "kolmas" "neljas" "viies" "kuues" "seitsmes" "kaheksas" "heksas" "kmnes"))
(define kymned_l_j '("null" "he" "kahe" "kolme" "nelja" "viie" "kuue" "seitsme" "kaheksa" "heksa" "kmne"))

(define (yhed dw j)
	"Kui j = 1 siis jrgarv"
(let ((nr (parse-number dw)))
	(cond
		((eq? j 0) (list (nth nr yhed_l)))
		((eq? j 1) (list (nth nr yhed_l_j)))
		((eq? j 2) (list (nth nr kymned_l_j))))))

(define (teised dw j)
(let ((rw ())(nr (- (parse-number dw) 10)))
	(cond
	((< j 1)(append rw (yhed nr j) '("teist")))
	((< j 2)(append rw (yhed nr 2) '("teist" "kmnes")))
	((< j 3)(append rw (yhed nr 2) '("teist" "kmne"))))))


(define (kymned dw j)
(let ((rw ()) (nr (parse-number dw)) (sp (parse-number (substring dw  (- (length dw) 1) 1))))
	(cond
		((< nr 11) (append rw (yhed dw j)))
		((< nr 20) (append rw (teised dw j)))
		((< nr 100) 
				(if (eq? j 0)
						(append rw (yhed (substring dw (- (length dw) 2) 1) j) '("kmmend") (if (> sp 0) (yhed sp j))) 
						(append rw (yhed (substring dw (- (length dw) 2) 1) 2)  
						(if (> sp 0) (list "kmne")
												 (list "kmnes")) 
						(if (> sp 0) (yhed sp j))))))))

(define (sajad dw j)
(let ((rw ()) (nr (parse-number dw)) (fp (parse-number (substring dw 0 1)))  (sp (kymned (substring dw  1 2) j)))
(if (> j 0)
 (cond
	((< nr 100)(append rw (kymned dw j)))
	((eqv? nr 100)(if (eqv? j 1) (append rw '("sajas"))(append rw '("saja"))))
	((eqv? fp 1)(append rw '("saja") sp ))
	((append rw (yhed fp 2) '("saja") sp )))
 (cond
	((< nr 100)(append rw (kymned dw j)))
	((eqv? nr 100)(append rw '("sada")))
	((eqv? fp 1)(append rw '("sada") sp ))
	((append rw (yhed fp 0) '("sada") sp ))))))


(define (tuhanded dw j)
(let 
		((rw ()) (nr (parse-number dw)) 
		(fp (substring dw 0 (- (length dw) 3)))
		(sp (sajad (substring dw  (- (length dw) 3) 3) j)))

(if (string-equal (car sp) "sada") (set! sp (append '("ks") sp )))
(set! nr (parse-number fp))
(if (string-equal (car sp) "null")(set! sp '()))
(if (> j 0) (set! tuhat '("tuhande")) (set! tuhat '("tuhat")))

(cond
((< (parse-number dw) 1000)(append rw (sajad (parse-number dw) j)))
((eq? nr 1)(append rw tuhat sp))
((append rw (sajad fp j) '("tuhat") sp)))))





(define (eki_et_estonian_digits name j)
(let ((rv) (nr (parse-number name)))
	(cond
		((< nr 11)(set! rv (yhed name j)))
		((< nr 100)(set! rv (kymned name j)))
		((< nr 1000)(set! rv (sajad name j)))
		((< nr 1000000)(set! rv (tuhanded name j)))
	(list (symbolexplode name)))))




(define (komaga name mis millega j)
(let ((rv)(sp (string-after name mis)))
(append rv 	(eki_et_estonian_digits (string-before name mis) 0)
						(list millega)
						(cond
							((or (string-equal "0" (substring sp 0 1)) (> (length sp) 3)) 
									(symbolexplode sp))
							((eki_et_estonian_digits sp j))))))




(define (string-pos name match)
(let ((rv 0) (lugeja 0))
	(while (< rv 1) 
		(begin
			(if (string-matches (substring name lugeja 1) match) (set! rv lugeja))
			(set! lugeja (+ lugeja 1))))
	(set! rv rv)))


(define (string-remove string1 string2)
"(string-remove STRING1 STRING2)
Remove all instances of STRING2 in STRING1 and return the result."
    (begin
       (while (and (not (equal? string1 string2))
                        (or (not (equal? (string-before string1 string2) ""))
                            (not (equal? (string-after  string1 string2) ""))
                        )
               )
              (let (before after)
                  (set! before (string-before string1 string2))
                  (set! after  (string-after string1 string2))
    			(set! string1 (string-append before after))
              )
        )
	  (if (equal? string1 string2) "" string1)
    )
)



(define (kuupaev name)
(let ((rv)(fp (string-before name ".")))
	(set! name (string-after name "."))
		(append rv (eki_et_estonian_digits fp 0)
			(eki_et_estonian_digits (string-before name ".") 0) 
			(eki_et_estonian_digits (string-after name ".") 0))))


(define (eki_et_estonian_numbers name j token)
"Tokenile tegin juurde featuuri 'type' kuna sisseehitatud token_pos annab suvaliselt
'cardinal' vi 'digit'. Hetkel ainus vrtus '1' "
(let ((rv) (nr (parse-number name)) (fp) (thp))

	(item.set_feat token "type" "1")
		;(print (item.feat token "p.type"))
		;(print (item.features token))

(if (string-matches name "[0-9\.,]+\-[a-zA-Z]+") 
			(begin
				(set! thp (list (string-after name "-")))
					(set! name (string-before name "-"))
						(set! j 2)))
(if (string-matches name "[0-9\.,]+[a-zA-Z]+") 
			(begin 
				(set! pos (string-pos name "[a-zA-Z]"))
				(set! thp (list (substring name pos (- (length name) pos))))
					(set! name (substring name 0 pos))
						(set! j 2)))

(if (string-matches name "\-[0-9\.,]+")
			(begin
				(set! fp '("miinus"))
					(set! name (substring name 1  (- (length name) 1))))) 


(cond
((and (string-equal name "000") (string-equal (item.feat token "p.type") "1" ))
		(append rv '("tuhat"))) ; 1 000 000 = ks tuhat tuhat
((string-matches name "[0-9]+")
		(set! rv  (append fp (eki_et_estonian_digits name j) thp)))
((string-matches name "[0-9]+\-[0-9]+")	
		(append rv fp (komaga name "-" "miinus" j)))
((string-matches name "[0-9]+:[0-9]+")	
		(append rv fp (komaga name ":" "" j))) ;enamus on jalka tulemused vi kell siiski?
((string-matches name "[0-9]+,[0-9]+")	
		(append rv fp (komaga name "," "koma" j) thp))
((string-matches name "[0-9]+\.[0-9]+")	
		(append rv fp (komaga name "." "koma" j) thp))
((string-matches name "[0-9]+\.[0-9]+\.[1-9][0-9][0-9][0-9]") ;kuupev
		(append rv (kuupaev name)))
(list (append fp (symbolexplode name) thp))
)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; PALAT ;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(define (pal j)
  (cond 
	((eq? j 'l)(set! j 'L))
	((eq? j 'n)(set! j 'N))
	((eq? j 's)(set! j 'S))
	((eq? j 't)(set! j 'T))
	((eq? j 'd)(set! j 'D))
  (t (set! j j))))

;(print "-------")
;(print (pal 'k))
;(print "-------")


(define (palat p)

	(set! syl)
	(set! pls)
	(set! js)
	(set! rohk nil)
;(print "---1---")

	(if (> (length p) 1) ; kui silpide arv on suurem kui 1
		(begin
			(set! snr 0)
			(set! s1 (car(car p)))
			(set! ls1 (length s1))
			(if (> ls1 1)
				(begin
					(set! s1 (reverse s1))
					(set! h11 (car s1))			
					(set! h12 (cadr s1))
				)
				(begin
					(set! h11 (car s1))			
					(set! h12 '0)
				)
			)
			(set! s2 (car(cadr p)))
			(set! ls2 (length s2))				
			(if (> ls2 1)
				(begin
					(set! h21 (car s2))
					(set! h22 (car(cdr s2)))
				)
				(begin
					(set! h21 (car s2))
					(set! h22 '0)
				)
			)

			(while p
				(set! pls (car p))
				(set! rohk (cdr pls))
				(set! snr (+ snr 1)) ;snr=snr+1
				(if (and (eq? snr 1) (> ls1 1))
					(if (or (and (eq? h21 'j) (eki_et_is_vowel h12)) (and (eq? h22 'i) (eq? h11 h21)))
						(begin
							(set! esm 1)
							(while s1
								(set! jh (car s1))
								(set! s1 (cdr s1))
								(if (eq? esm 1)
									(begin
										(set! jh (pal jh))
										(set! esm 0)
									)
								)
								(set! js (cons jh js))
							)
							(set! pls (cons js rohk))
						)
					)
				)
				(if (and (eq? snr 2) (> ls2 1))
					(if(and (eq? h22 'i) (or (eq? h11 h21) (eki_et_is_vowel h11)))
						(begin 
							(set! esm 1)
							(while s2
								(set! jh (car s2))
								(set! s2 (cdr s2))
								(if (eq? esm 1)
									(begin	
										(set! jh (pal jh))
										(set! esm 0)
									)
								)
								(set! js (cons jh js))
							)
							(set! pls (cons (reverse js) rohk))
						)
					)
				)		
				(set! syl (cons pls syl))
				(set! p (cdr p))
				(set! js nil)
			)
		)
		(set! syl (reverse p))
	)
	(set! p (reverse syl))
); palat










(provide 'eki_et_tonu_tokendata)
